
        include \MASM32\INCLUDE\masm32rt.inc

WinMain    proto :DWORD,:DWORD,:DWORD,:DWORD
CreateMask proto :HBITMAP,:COLORREF

MAINBITMAP equ   500             ; BITMAP

        .data

ClassName   db "MainWinClass",0
AppName     db "Main Window",0
ClassStatic db "Static",0
ClassButt   db "Button",0
NameStatic1 db "Mydraw1",0
NameStatic2 db "Mydraw2",0

        .data?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?
hstatic1    HWND      ?
hstatic2    HWND      ?
hbutton     HWND      ?
hBit        HBITMAP   ?
HTBit       HBITMAP   ?
dwBmpWidth  dd        ?
dwBmpHeight dd        ?

        .code

start:  invoke  GetModuleHandle,NULL
        mov     hInstance,eax	
        invoke  GetCommandLine
        mov     CommandLine,eax
        invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
        invoke  ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

        LOCAL   wc   :WNDCLASSEX
        LOCAL   msg  :MSG
        LOCAL   hwnd :HWND

        mov     wc.cbSize,SIZEOF WNDCLASSEX
        mov     wc.style, CS_HREDRAW or CS_VREDRAW
        mov     wc.lpfnWndProc, OFFSET WndProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        push    hInst
        pop     wc.hInstance
        mov     wc.hbrBackground,COLOR_BTNFACE+1
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,OFFSET ClassName
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx, addr wc

        invoke  CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,
                WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,
                100h,100h,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        invoke  ShowWindow, hwnd,SW_SHOWNORMAL
        invoke  UpdateWindow, hwnd

    .while TRUE
        invoke  GetMessage,ADDR msg,NULL,0,0
    .break .if (!eax)
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg
    .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

        LOCAL   hdc1     :HDC
        LOCAL   hBmpOrg  :HBITMAP
	LOCAL   Bm       :BITMAP
	LOCAL   ps       :PAINTSTRUCT
	LOCAL   hdc10    :HDC
	LOCAL   hMem10   :HDC

    .if uMsg==WM_DESTROY
        invoke  DeleteObject,HTBit
        invoke  DeleteObject,hBit
        invoke  PostQuitMessage,NULL

    .elseif uMsg==WM_CREATE
        invoke  CreateWindowEx,NULL,addr ClassButt,addr AppName,
                WS_CHILD or WS_VISIBLE,60,50,100,26,hWnd,NULL,hInstance,NULL
        mov     hbutton,eax
        invoke  LoadBitmap,hInstance,MAINBITMAP
        mov     hBit,eax
        invoke  CreateMask,eax,0FF00FFh			
        mov     HTBit,eax                       ; save mask
        invoke  GetObject,hBit,sizeof Bm,addr Bm
        push    Bm.bmWidth
        pop     dwBmpWidth
        push    Bm.bmHeight
        pop     dwBmpHeight

    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
        mov     hdc10,eax
        invoke  CreateCompatibleDC,hdc10
        mov     hMem10,eax
        invoke  SelectObject,hMem10,HTBit
        mov     hBmpOrg,eax
        invoke  BitBlt,hdc10,0,0,dwBmpWidth,dwBmpHeight,hMem10,0,0,SRCAND
        invoke  SelectObject,hMem10,hBit
        invoke  BitBlt,hdc10,0,0,dwBmpWidth,dwBmpHeight,hMem10,0,0,SRCPAINT
        invoke  SelectObject,hMem10,hBmpOrg
        invoke  DeleteDC,hMem10
        invoke  EndPaint,hWnd,addr ps

    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
        ret

    .endif

    xor     eax,eax
    ret

WndProc endp

CreateMask proc hBitmap:HBITMAP,crTransparent:COLORREF

;b =255
;g =0 
;r =255
;result = 00FF00FFh

        LOCAL   HDC1      :HDC
        LOCAL   HDC2      :HDC
        LOCAL   hBMask    :HBITMAP
        LOCAL   hbmpPrev1 :HBITMAP
        LOCAL   hbmpPrev2 :HBITMAP
        LOCAL   Bm        :BITMAP

        invoke  GetObject,hBitmap,sizeof(BITMAP),addr Bm
        invoke  CreateBitmap,Bm.bmWidth,Bm.bmHeight,1,1,NULL
        mov     hBMask,eax
        invoke  CreateCompatibleDC,0
        mov     HDC1,eax
        invoke  CreateCompatibleDC,0	
        mov     HDC2,eax
        invoke  SelectObject,HDC1,hBitmap
        mov     hbmpPrev1,eax
        invoke  SelectObject,HDC2,hBMask
        mov     hbmpPrev2,eax
        invoke  SetBkColor,HDC1,crTransparent
        invoke  BitBlt,HDC2,0,0,Bm.bmWidth,Bm.bmHeight,HDC1,0,0,SRCCOPY
        invoke  BitBlt,HDC1,0,0,Bm.bmWidth,Bm.bmHeight,HDC2,0,0,SRCINVERT
        invoke  SelectObject,HDC2,hbmpPrev2
        invoke  SelectObject,HDC1,hbmpPrev1
        invoke  DeleteDC,HDC1
        invoke  DeleteDC,HDC2
        mov     eax,hBMask
        ret

CreateMask endp

        end   start

